(define (domain faults)
 (:types operation fault)
 (:constants f1 f2 f3 - fault
             o1 o2 o3 - operation)
 (:predicates 
   (not_completed ?o - operation)
   (completed ?o - operation)
   (fault ?f - fault)
   (not_fault ?f - fault)
   (faulted_op ?o - operation ?f - fault)
   (last_fault ?f)
   (made)
  )

 (:action perform_operation
  :parameters (?o - operation)
  :precondition (and (not_completed ?o) (not_fault f3))
  :effect (and (completed ?o) (not (not_completed ?o)) 
               (when (and (not_fault f1) (not_fault f2) (not_fault f3))
                     (oneof (and) (and (fault f1) (not (not_fault f1)) 
                                       (faulted_op ?o f1) (last_fault f1))))
               (when (and (fault f1) (not_fault f2) (not_fault f3))
                     (oneof (and) (and (fault f2) (not (not_fault f2))
                                       (faulted_op ?o f2) (last_fault f2) 
                                       (not (last_fault f1)))))
               (when (and (fault f1) (fault f2) (not_fault f3))
                     (oneof (and) (and (fault f3) (not (not_fault f3))
                                       (faulted_op ?o f3) (last_fault f3)
                                       (not (last_fault f2)))))
          ) 
 )

 (:action repair_fault
  :parameters (?o - operation ?f - fault)
  :precondition (and (faulted_op ?o ?f) (last_fault ?f))
  :effect (and (not (faulted_op ?o ?f)) 
               (not_completed ?o) (not (completed ?o))
               (when (last_fault f1) (not (last_fault f1)))
               (when (last_fault f2) (and (not (last_fault f2)) 
                                          (last_fault f1)))
               (when (last_fault f3) (and (not (last_fault f3)) 
                                          (last_fault f2)))
          )
 )
 

 ;;allow only two faults
 (:action finish 
  :precondition (and (completed o1) 
                     (completed o2)
                     (completed o3)                   
                 )
  :effect (and (when (last_fault f1) (made))
               (when (last_fault f2) (made))
          )
 )
)

